<i18n>
  {
    "fr": {
      "my-laboratory": "Mon laboratoire",
      "initiatives": "Les initiatives",
      "ghgis": "Les BGES",
      "scenarios": "Les scénarios",
      "compare-ghgis": "Comparez les BGES",
      "others": "Autres",
      "links": "Liens"
    },
    "en": {
      "my-laboratory": "My laboratory",
      "initiatives": "Initiatives",
      "ghgis": "GHG inventories",
      "scenarios": "The scenarios",
      "compare-ghgis": "Compare GHGIs",
      "others": "Others",
      "links": "Links"
    }
  }
</i18n>

<template>
  <section class="hero is-default is-bold">
    <div class="hero-body">
      <div class="container">
        <div class="columns">
          <div class="column is-2">
            <b-menu>
              <b-menu-list label="Administration" v-if="isSuperUser">
                <b-menu-item
                  :active="activeModule==='ges-1point5-admin'"
                  @click="activate('ges-1point5-admin')"
                >
                  <template slot="label">
                    <nav class="level">
                      <div class="level-left">
                        <div class="level-item">
                          <b-icon icon="thermometer"></b-icon>
                          GES 1point5
                        </div>
                      </div>
                    </nav>
                  </template>
                </b-menu-item>
                <b-menu-item
                  :active="activeModule==='initiatives-admin'"
                  @click="activate('initiatives-admin')"
                >
                  <template slot="label">
                    <nav class="level">
                      <div class="level-left">
                        <div class="level-item">
                          <b-icon icon="lightbulb-o"></b-icon>
                          {{ $t('initiatives') }}
                        </div>
                      </div>
                    </nav>
                  </template>
                </b-menu-item>
              </b-menu-list>
              <b-menu-list :label="$t('my-laboratory')">
                <b-menu-item
                  :active="activeModule==='my-laboratory'"
                  @click="activate('my-laboratory')"
                >
                  <template slot="label">
                    <nav class="level">
                      <div class="level-left">
                        <div class="level-item">
                          <b-icon icon="flask"></b-icon>
                          {{ $t('my-laboratory') }}
                        </div>
                      </div>
                    </nav>
                  </template>
                </b-menu-item>
                <b-menu-item
                  :active="activeModule==='all-ghgi'"
                  @click="activate('all-ghgi')"
                >
                  <template slot="label">
                    <nav class="level">
                      <div class="level-left">
                        <div class="level-item">
                          <b-icon icon="thermometer"></b-icon>
                          {{ $t('ghgis') }}
                        </div>
                      </div>
                    </nav>
                  </template>
                </b-menu-item>
                <b-menu-item
                  :active="activeModule==='ghgi-comparison'"
                  @click="activate('ghgi-comparison')"
                >
                  <template slot="label">
                    <nav class="level">
                      <div class="level-left">
                        <div class="level-item">
                          <b-icon icon="line-chart"></b-icon>
                          {{ $t('compare-ghgis') }}
                        </div>
                      </div>
                    </nav>
                  </template>
                </b-menu-item>
                <!-- <b-menu-item
                  :active="activeModule==='all-scenarios'"
                  @click="activate('all-scenarios')"
                >
                  <template slot="label">
                    <nav class="level">
                      <div class="level-left">
                        <div class="level-item">
                          <b-icon icon="crosshairs"></b-icon>
                          {{ $t('scenarios') }}
                        </div>
                      </div>
                    </nav>
                  </template>
                </b-menu-item> -->
                <b-menu-item
                  :active="activeModule==='initiatives'"
                  @click="activate('initiatives')"
                >
                  <template slot="label">
                    <nav class="level">
                      <div class="level-left">
                        <div class="level-item">
                          <b-icon icon="lightbulb-o"></b-icon>
                          {{ $t('initiatives') }}
                        </div>
                      </div>
                    </nav>
                  </template>
                </b-menu-item>
              </b-menu-list>
              <b-menu-list :label="$t('others')">
                <b-menu-item
                  :active="activeModule==='links'"
                  @click="activate('links')"
                >
                  <template slot="label">
                    <nav class="level">
                      <div class="level-left">
                        <div class="level-item">
                          <b-icon icon="external-link-square"></b-icon>
                          {{ $t('links') }}
                        </div>
                      </div>
                    </nav>
                  </template>
                </b-menu-item>
              </b-menu-list>
            </b-menu>
          </div>
          <div class="column">
            <ges-1point5-admin v-if="activeModule==='ges-1point5-admin'"/>
            <initiatives-admin v-if="activeModule==='initiatives-admin'"/>
            <ghgi-comparison v-if="activeModule==='ghgi-comparison'"/>
            <all-ghgi v-if="activeModule==='all-ghgi'"/>
            <my-laboratory v-if="activeModule==='my-laboratory'"/>
            <initiatives v-if="activeModule==='initiatives'"/>
            <all-scenarios v-if="activeModule==='all-scenarios'"/>
            <div v-if="activeModule==='links'">
              <links />
            </div>
          </div>
        </div>
      </div>
    </div>
  </section>
</template>

<script>
import { mapGetters } from 'vuex'

export default {
  name: 'Administration',
  components: {
    'ges-1point5-admin': () => import('@/components/admin/GES1point5Admin.vue'),
    'initiatives-admin': () => import('@/components/admin/InitiativesAdmin.vue'),
    'ghgi-comparison': () => import('@/components/admin/GHGIComparison.vue'),
    'all-ghgi': () => import('@/components/admin/AllGHGI.vue'),
    'my-laboratory': () => import('@/components/admin/MyLaboratory.vue'),
    'all-scenarios': () => import('@/components/admin/AllScenarios.vue'),
    'initiatives': () => import('@/components/admin/MyInititatives.vue'),
    'links': () => import('@/components/admin/Links.vue')
  },
  data () {
    return {
      activeModule: 'all-ghgi'
    }
  },
  computed: {
    ...mapGetters('authentication', ['isAuthenticated']),
    isSuperUser: function () {
      return this.$store.getters['authentication/isSuperUser']
    },
    routeParam: function () {
      return this.$route.params.name
    }
  },
  watch: {
    routeParam: function () {
      this.activate(this.routeParam)
    }
  },
  methods: {
    activate: function (module) {
      this.activeModule = module
      this.$router.push('/administration/' + module).catch(() => {})
    }
  },
  mounted () {
    if (this.isAuthenticated) {
      const loadingComponent = this.$buefy.loading.open({
        container: null
      })
      this.$store.dispatch('admin/getAllGHGI')
        .then(data => {
          loadingComponent.close()
        })
        .catch((erreur) => {
          loadingComponent.close()
        })
    }
    if (this.routeParam) {
      this.activate(this.routeParam)
    }
  }
}
</script>
